c     +---------------------------------------------------+
c     + subroutine : bh matrix                            +
c     +---------------------------------------------------+
      subroutine bhm(idim,jdim,nana,bh,latana,lonana,
     +           latm,lonm,dlat,dlon,clat,sdevfg,gscale)
      implicit  none
      integer 	idim,jdim,nana
      real 	latm,lonm,dlat,dlon,clat,sdevfg,gscale
      real 	bh(idim*jdim,nana),latana(nana),lonana(nana)

      integer k,l,ki,kj
      real    klat,klon,llat,llon,clon,cov,varian,dis2
      real    pi

      pi = asin(1.)*2.

      clon   = clat*cos(latm*pi/180.)
      varian = sdevfg*sdevfg

c     diagnal elements modification, due to binv

      do k=1,idim*jdim
	 kj = k/idim
	 if(mod(k,idim).ne.0) kj=kj+1
	 ki = k -(kj-1)*idim
	 klat = latm + (kj-(jdim/2+1))*dlat
	 klon = lonm + (ki-(idim/2+1))*dlon
      do l=1,nana
         dis2 = (  ((klat-latana(l))*clat)**2+
     +             ((klon-lonana(l))*clon)**2  ) 
     +           / gscale**2
         bh(k,l)  = varian*exp( -dis2 )
      enddo
      enddo
      end
