c     +---------------------------------------------------+
c     + subroutine : b matrix                             +
c     +---------------------------------------------------+
      subroutine bmatrix(idim,jdim,b,latm,lonm,dlat,dlon,clat,
     +                   sdevfg,gscale,ischeme)
      implicit  none
      integer 	idim,jdim
      integer 	ischeme
      real      diaoff
      real 	latm,lonm,dlat,dlon,clat,sdevfg,gscale
      real 	b(idim*jdim,idim*jdim)

      integer k,l,ki,kj,li,lj
      real    klat,klon,llat,llon,clon,cov,varian,dis2
      real    pi

      pi = asin(1.)*2.

      clon   = clat*cos(latm*pi/180.)
      varian = sdevfg*sdevfg

c     diagnal elements modification, due to binv
      if(ischeme.eq.1) then
	 diaoff = 1.2
	 write(6,*) 'diaoff =',diaoff
      else
	 diaoff = 1.
      endif

      do k=2,idim*jdim
	 kj = k/idim
	 if(mod(k,idim).ne.0) kj=kj+1
	 ki = k -(kj-1)*idim
	 klat = latm + (kj-(jdim/2+1))*dlat
	 klon = lonm + (ki-(idim/2+1))*dlon
      do l=1,k-1
	 lj = l/idim
	 if(mod(l,idim).ne.0) lj=lj+1
	 li = l -(lj-1)*idim
	 llat = latm + (lj-(jdim/2+1))*dlat
	 llon = lonm + (li-(idim/2+1))*dlon
         dis2 = (  ((klat-llat)*clat)**2+
     +             ((klon-llon)*clon)**2  ) 
     +           / gscale**2
         cov  = varian*exp( -dis2 )
         b(k,l) = cov
         b(l,k) = cov
      enddo
      enddo
      do k=1,idim*jdim
         b(k,k) = varian*diaoff
      enddo
      end
