      subroutine llcrv(x,y,n,mark,mrkdec,ltype,hgtmrk,
     1                 xmin,xmax,ymin,ymax,latlon)
c
#include "comxyh.inc"

      real x(1),y(1),hgtmrk,mark,xmin,xmax,ymin,ymax
      integer n,ltype
      character*3 latlon
      character*4 chll
c
      real cradi,eps
c
      data cradi /57.295780/, eps/1.e-5/
c
       IF(PUBLICATION) THEN
C       ====================

      imark = int(mark)
      ndig = 1
      if( iabs(imark).gt.9 ) ndig = 2
      if( iabs(imark).gt.99 ) ndig = 3
      if( mark.lt.0. ) ndig = ndig + 1
      if( mrkdec.gt.0 ) ndig = ndig + mrkdec + 1

      if(latlon.eq.'lat') then
         dischr=float(ndig+1)*hgtmrk*0.8
      else
         dischr=2.*hgtmrk*0.8
      endif
c
c no label if ...
c  1. closed line or very short line
      dist = sqrt((x(1)-x(n))**2+(y(1)-y(n))**2)
      if(dist.le.dischr*2 .or. n.le.3) then
         call linex(x,y,n,ltype)
        return
      endif
c  2. lat not from xmin
      if(latlon.eq.'lat') then
         dist = sqrt((x(1)-xmin)**2)
         if(dist.gt.eps) then
            call linex(x,y,n,ltype)
           return
         endif
      endif
c  3. lon not from xmin
      if(latlon.eq.'lon') then
         dist = sqrt((y(1)-ymin)**2)
         if(dist.gt.eps) then
            call linex(x,y,n,ltype)
           return
         endif
      endif
c
      if(latlon.eq.'lat') then
        xx  = x(1) - 4.5*hgtmrk/2.
        yy  = y(1) - 0.5*hgtmrk/2.
      else
        xx  = x(1) - 2.0*hgtmrk/2.
        yy  = y(1) - 2.0*hgtmrk/2.
      endif
c
      ang = 0
      if( mrkdec.gt.0 ) then
         call numbex(xx,yy,hgtmrk,mark,ang,ndig,mrkdec)
      else
        if(latlon.eq.'lat') then
           if(imark.gt.0) then
              write(chll(1:4),'(i3,a1)') abs(imark),'N'
           else if(imark.lt.0) then
              write(chll(1:4),'(i3,a1)') abs(imark),'S'
           else
              write(chll(1:4),'(i3,a1)') abs(imark),' '
           endif
        else
           if(imark.gt.0) then
              write(chll(1:4),'(i3,a1)') abs(imark),'E'
           else if(imark.lt.0) then
              write(chll(1:4),'(i3,a1)') abs(imark),'W'
           else
              xx = xx + 0.5*hgtmrk
              write(chll(1:4),'(i3,a1)') abs(imark),' '
           endif
        endif
chans    call numbex(xx,yy,hgtmrk,mark,ang,ndig,0)
         call symbex(xx,yy,0.5*hgtmrk,chll,ang,4)
      endif
c
      call linex(x,y,n,ltype)
      return

C OLD PROGRAM
       ELSE

      if(.not.latlonlab) then
         call linex(x,y,n,ltype)
         return
      endif

      imark = int(mark)
      ndig = 1
      if( iabs(imark).gt.9 ) ndig = 2
      if( iabs(imark).gt.99 ) ndig = 3
      if( mark.lt.0. ) ndig = ndig + 1
      if( mrkdec.gt.0 ) ndig = ndig + mrkdec + 1
      dischr=float(ndig+1)*hgtmrk*0.8
c
      dist = sqrt((x(1)-x(n))**2+(y(1)-y(n))**2)
      if(dist.le.dischr*2. .or. n.le.3) then
         call linex(x,y,n,ltype)
        return
      endif
c
c
      x(n+1)=0.
      x(n+2)=1.
      y(n+1)=0.
      y(n+2)=1.
      nn=n/2
      nn1=nn
      nn2=nn+1
c
  320 dist = sqrt((x(nn1)-x(nn2))**2+(y(nn1)-y(nn2))**2)
c
      if( dist.ge.dischr ) goto 390
c
      if( nn2.lt.n .and.
     x         (x(nn2+1)-x(nn2))*(x(nn+1)-x(nn)).ge.0. )then
        nn2=nn2+1
        goto 320
      endif
c
      if( nn1.gt.1 .and.
     x         (x(nn1)-x(nn1-1))*(x(nn+1)-x(nn)).ge.0. )then
        nn1=nn1-1
        goto 320
      endif
c
      nnnn = 1
      goto 900
c
  390 ang=atan2(y(nn1)-y(nn2),x(nn1)-x(nn2))*cradi
      sinang = (y(nn2)-y(nn1))/dist
      cosang = (x(nn2)-x(nn1))/dist
      xsave = x(nn1) + cosang*dischr
      ysave = y(nn1) + sinang*dischr
      zhgt = 0.2*hgtmrk
      x1ch = x(nn1) + cosang*zhgt
      y1ch = y(nn1) + sinang*zhgt
      x2ch = xsave  - cosang*zhgt
      y2ch = ysave  - sinang*zhgt
      if( ang.lt.-90. ) ang=ang+180.
      if( ang.gt.+90. ) ang=ang-180.
      nnnn=nn1
      xnnp1=x(nnnn+1)
      ynnp1=y(nnnn+1)
      xnnp2=x(nnnn+2)
      ynnp2=y(nnnn+2)
      x(nnnn+1)=0.
      x(nnnn+2)=1.
      y(nnnn+1)=0.
      y(nnnn+2)=1.
c
      call linex(x,y,nnnn,ltype)
c
      x(nnnn+1)=xnnp1
      y(nnnn+1)=ynnp1
      x(nnnn+2)=xnnp2
      y(nnnn+2)=ynnp2
c
      zhgt = 0.5*hgtmrk
      if( x1ch.lt.x2ch ) then
        xx = x1ch + zhgt*sinang
        yy = y1ch - zhgt*cosang
      else
        xx =x2ch - zhgt*sinang
        yy =y2ch + zhgt*cosang
      endif
c
      zvalue = mark
      if( mrkdec.gt.0 ) then
         call numbex(xx,yy,hgtmrk,zvalue,ang,ndig,mrkdec)
      else
         call numbex(xx,yy,hgtmrk,zvalue,ang,ndig,0)
      endif
c
      nnnn=nn2-1
      x(nnnn) = xsave
      y(nnnn) = ysave
c
  900 call linex(x(nnnn),y(nnnn),n-nnnn+1,ltype)
c
      return
      ENDIF
      end

