      subroutine obsar(tplot,pplot,nobs,ii,iii,latobs,lonobs,
     x       pobs,tobs,pflag,tflag,
     x       obsize,xorigo,yorigo,xmin,xmax,ymin,ymax)
c
      logical tplot,pplot
      integer nobs
      integer ii(nobs),iii(nobs),latobs(nobs),lonobs(nobs)
      real   pobs(nobs),tobs(nobs)
      integer pflag(nobs),tflag(nobs)
      real obsize,xorigo,xmin,xmax,
     x  yorigo,ymin,ymax
c
c-----------------------------------------------------------------------------
c
      integer colmark
c
c-----------------------------------------------------------------------------
c
      tref = 273.15

      do kobs=1,nobs
c
c
      lat = latobs(kobs)
      lon = lonobs(kobs)
c
      call xyobs(lat,lon,xobs,yobs,tilt)
c
      xobs = xobs + xorigo
      yobs = yobs + yorigo
c
c check available space for plotting
c
      if( xobs.ge.(xmin+obsize) .and.
     x xobs.le.(xmax-5*obsize) .and.
     x yobs.ge.(ymin+obsize) .and.
     x yobs.le.(ymax-obsize)) then
c
      icol = 0
c
c decide color 
c
      if( pplot ) then
        ndec = 0
        if( pflag(kobs).eq.0 ) then
           icol=1
        else if( pflag(kobs).eq.1 ) then
           icol=24
        else if( pflag(kobs).eq.2 ) then
           icol=28
        endif
      else if( tplot ) then
        ndec = 1
        if( tflag(kobs).eq.0 ) then
           icol=1
        else if( tflag(kobs).eq.1 ) then
           icol=24
        else if( tflag(kobs).eq.2 ) then
           icol=28
        else
           icol=25
        endif
      endif
c
c start plotting
c
      if(icol.gt.0) then

         call newpex(1,icol)
         xplot = xobs+0.5*obsize
         yplot = yobs-0.5*obsize
c
c plot obs position
c
         call obsxy(xobs,yobs,obsize)
c
c plot obs value
c
         if( pplot ) then
           if(pobs(kobs).ge.1000) xx = pobs(kobs)-1000.
           if(pobs(kobs).ge. 900) xx = pobs(kobs)- 900.
           ndig = 4
           ndec = 1
         else if( tplot ) then
           xx = tobs(kobs)-tref
           ndig = 4
           if(xx.lt.10.and.xx.ge.0) ndig = 3
           ndec = 1
         endif
        call numbex(xplot,yplot,obsize,xx,0.,ndig,ndec)

      endif
c
      endif

      enddo
c
      return
      end
