c     +---------------------------------------------------+
c     + datalib :                                         +
c     +---------------------------------------------------+

c     ------ subroutine getfld : get analysis ------------------------
      subroutine getfld(nx,ny,fld,lunin)
      integer nx,ny,lunin
      character*50 nam
      real fld(nx,ny)
      read(lunin,'(a)') nam
      write(6,'(a)') nam
      do j=1,ny
         read(lunin,*) (fld(i,j),i=1,nx)
      enddo
      end
c     ------  subroutine getobs : get observations -------------------
      subroutine getobs(lunobs,npar,mobs,nobs,
     +                  iiiobs,nrobs,latobs,lonobs,oriobs,flgobs)
      integer lunobs,npar,nobs,
     +        iiiobs(mobs),nrobs(mobs),flgobs(mobs,npar)
      real    oriobs(mobs,npar),latobs(mobs),lonobs(mobs)
      integer n,ii,iii,ilat,ilon
      real    par(2)
      nobs = 0
      do while (nobs.le.mobs)
         read(lunobs,*,end=999,err=200) ii,iii,ilat,ilon,par
         nobs=nobs+1
         iiiobs(nobs)=ii*10000+iii
         nrobs(nobs)=nobs
         latobs(nobs)=float(ilat)/1000.
         lonobs(nobs)=float(ilon)/1000.
	 do  n=1,npar
            oriobs(nobs,n)=par(n)
            if(par(n).lt.0)flgobs(nobs,n)=3
	 enddo
      enddo
      stop ' mobs underdimensionerad in nart_box!'
  200 stop ' read-error on input-file. nart_box'
  999 continue
      if(nobs.eq.0) stop 'no observation at all'
      write(6,'(3x,a,4x,i5)') ' nobs in all:',nobs
      return
      end
c     ------ subroutine putfld : store analysis ----------------------
      subroutine putfld(nam,lunut,nx,ny,fld,nxp,nyp)
      integer lunut,nx,ny,nxp,nyp
      character*(*) nam
      real fld(nx,ny)
      write(lunut,*) nam
      do j=1,nyp
         write(lunut,*) (fld(i,j),i=1,nxp)
      enddo
      end
c     ------ subroutine putobs : store observations -----------------
      subroutine putobs(nam,mobs,npar,nobs,lunut
     +,          iiiobs,latobs,lonobs,valobs,flgobs)
      character*(*) nam
      integer mobs,npar,nobs,lunut,iiiobs(nobs),flgobs(mobs,npar)
      real latobs(nobs),lonobs(nobs),valobs(mobs,npar)
      write(lunut,*) nam
      do k=1,nobs
         ii=iiiobs(k)/10000
         iii=iiiobs(k)-ii*10000
         ilat=int(latobs(k)*1000)
         ilon=int(lonobs(k)*1000)
         write(lunut,'(1x,2i4,2i8,2x,2f8.1,2i3)')
     +        ii,iii,ilat,ilon,
     +        (valobs(k,j),j=1,npar),(flgobs(k,j),j=1,npar)
      enddo
      end
c     ------ subroutine saveres : ??  -------------------------------
      subroutine saveres(mobs,npar,nana,ipar,nrana,flag,flgobs)
      integer mobs,npar,nana,ipar
      integer nrana(npar),flag(mobs,npar),flgobs(npar)
      do i=1,nana
         flag(nrana(i),ipar)=flgobs(i)
      enddo
      end
